/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function() {

	dojo.provide("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	
	/**
	 * <p>
	 * Common, shared place to put VVC Constants
	 * </p> 
	 */
	com.ibm.team.vvc.shared.web.ui.VvcConstants = {

		// Cache
		CONFIGURATION_CACHE_KEY: "com.ibm.team.vvc.configurationSessionCache",
			
		/* ----- DEPRECATED 4.0.2 ----- */
		DEFAULT_PAGE : "defaultPage",
		EDIT_CONFIGURATION_PAGE : "editConfiguration",
		EDIT_DIMENSION_PAGE : "editDimension",
		EDIT_DIMENSION_TYPE_PAGE : "editDimensionType",
		COMPARE_VIEWER_PAGE : "CompareViewer",
		WORKSPACE_PAGE : "WorkspaceEditor",
		SNAPSHOT_PAGE : "SnapshotEditor",
		ADD_DEPENDENCY_PAGE : "DependencyPicker",
		SHOW_EXPLORER: "showExplorer",
		CREATE_OPERATION: "operation=create",
		OPEN_OPERATION: "operation=open",
		ACTIVE_TAB_INDEX_COOKIE_NAME: "ActiveTabIndexListCookie",
		OLD_SHOW_CHANGESETS : "vvc.showChangesets",
		OLD_SHOW_HISTORY : "vvc.showHistory",
		OLD_REBASE_PICKER : "RebasePicker",
		OLD_VVC_CREATE_SNAPSHOT : "vvc.createSnapshot",
		OLD_VVC_CREATE_WORKSPACE : "vvc.createWorkspace",
		/* ---------------------------- */
	
		
		/* --- New '#action=' verbs --- */
		// Configurations
		CREATE_CONFIGURATION : "createNewConfiguration",
		VIEW_CONFIGURATION : "viewConfiguration",
		EDIT_CONFIGURATION : "editConfiguration",
		COMPARE_CONFIGURATIONS : "compareConfigurations",
		EXPLORE_COMPARISON : "compare",
		EXPLORE_CONFIGURATIONS : "exploreConfigurations",
		
		// Workspaces
		CREATE_WORKSPACE : "createNewWorkspace",
		VIEW_WORKSPACE : "viewWorkspace",
		EDIT_WORKSPACE : "editWorkspace",
		COMPARE_WORKSPACES : "compareWorkspaces",
		EXPLORE_WORKSPACES : "exploreWorkspaces",	// TODO: (amooz) investigate this term!
		
		// Workspace Explorer 2.0
		EXPLORER_FLOW_VIEW: "flow",
		EXPLORER_DEPENDENCY_VIEW: "dependency",
		
		// Snapshots
		CREATE_SNAPSHOT : "createNewSnapshot",
		VIEW_SNAPSHOT : "viewSnapshot",
		EDIT_SNAPSHOT : "editSnapshot",
		COMPARE_SNAPSHOT : "compareSnapshots",
		EXPLORE_SNAPSHOTS : "exploreSnapshots",
		
		// Changesets
		CREATE_CHANGESET : "createNewChangeset",
		VIEW_CHANGESET : "viewChangeset",
		EDIT_CHANGESET : "editChangeset",
		COMPARE_CHANGESET : "compareChangesets",
		EXPLORE_CHANGESETS : "exploreChangesets",
		
		// Dimensions
		CREATE_DIMENSION : "createNewDimension",
		VIEW_DIMENSION : "viewDimension",
		EDIT_DIMENSION : "editDimension",
		EDIT_DIMENSION_TYPE : "editDimensionType",
		EXPLORE_DIMENSIONS : "exploreDimensions",
		
		// Misc
		DEFAULT : "vvc",
		SHOW_EXPLORER : "exploreConfigurations",	// TODO: REMOVE THIS!
		REFRESH_EXPLORER : "refreshConfigurationsExplorer",	// TODO: (amooz) investigate this term!
		SHOW_HISTORY : "exploreHistory",
		EDIT_BASE_CONFIGURATION : "rebase",
		EDIT_DEPENDENCIES : "editDependencies",
		/* ---------------------------- */
		
		// VVC App & Icons
		WORKSPACE_TYPE: "workspace",
		SNAPSHOT_TYPE: "snapshot",
		WORKSPACE_ICON_URI: dojo.moduleUrl("com.ibm.team.vvc.shared.web", "graphics/workspace.gif"),
		SNAPSHOT_ICON_URI: dojo.moduleUrl("com.ibm.team.vvc.shared.web", "graphics/snapshot.gif"),
		/* ---------------------------- */
		
		// VVC Explorer
		ROW_ADDED: "com.ibm.team..vvc.explorer.row.added",
		ROW_REMOVED: "com.ibm.team.vvc.explorer.row.removed",
		ROW_EXPANDED: "com.ibm.team.vvc.explorer.row.expanded",
		ROW_COLLAPSED: "com.ibm.team.vvc.explorer.row.collapsed",
		ROW_SELECTED: "com.ibm.team.vvc.explorer.row.selected",
		ROW_DESELECTED: "com.ibm.team.vvc.explorer.row.deselected",
		
		// Error Codes
		ERROR_CODE_EXISTS: "EXISTS",
		/* ---------------------------- */
		
		// Explorer
		PRESERVE_EXPANSION_STATE_STORAGE_KEY: "com.ibm.team.vvc.explorer.expansionState",
		PRESERVE_SELECTION_STATE_STORAGE_KEY: "com.ibm.team.vvc.explorer.selectionState",
		/* ---------------------------- */
		
		COMPARE_MERGE_FIND_PREVIOUS: "previous",
		SNAPSHOT: "snapshot",
		WORKSPACE: "workspace",
		
		VVC_URL_STORAGE_KEY: "com.ibm.team.vvc.vvcUrl"
	}
	
}());
