/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.admin.AdminMenu");

dojo.require("com.ibm.team.repository.web.ui.internal.admin.AdminMenu");

dojo.declare("com.ibm.team.vvc.server.core.ui.internal.admin.AdminMenu", com.ibm.team.repository.web.ui.internal.admin.AdminMenu, {
	
	_populateMenu: function() {
		if (!this.domNode) {
			return;
		}
		
		// Call inherited
		this.inherited(arguments);
		
		this._removeMenuItem("com.ibm.team.process.ProjectAreaManagement");
		this._removeMenuItem("com.ibm.team.process.ProcessTemplateManagement");
		this._removeMenuItem("com.ibm.team.reports.reportsManagementPage");
	},
	
	_removeMenuItem: function(itemToRemove) {
		var items = this.getItems();
		var removeItem = null;
		if (items && items.length) {
			for (var i = 0; i < items.length; i++) {
				var item = items[i];
				if (item.href && item.href.indexOf(itemToRemove) !== -1) {
					removeItem = item;
					break;
				}
			}
		}
		if (removeItem) {
			this.remove(removeItem);			
		}
	}
});

}());