/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

(function() {
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.ApplicationWizard");

dojo.require("jazz.ui.Wizard");

dojo.require("com.ibm.team.vvc.shared.web.ui.compare.EmbeddedWizard");

/*
 * Customized version of the wizard that supports ActionRegistry mechanisms
 * while maintaining wizard constructs (such as what step we are on, etc.).
 * 
 * This wizard class should be used for places that host the actual steps, not
 * for ExternalSteps.
 */
dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.ApplicationWizard", com.ibm.team.vvc.shared.web.ui.compare.EmbeddedWizard, {
	
	constructor: function(args) {
		// need to mixin in order to override the inner dojo class.
		this.contentWidget = dojo.mixin(this.contentWidget, {updateURI: this.updateURI});
	},
	
	setAction: function (actionStr) {
		this.contentWidget.action = actionStr;
	},
	
	updateURI: function (stepNumber) {
		// we override this method to update the URI in a VVC-specific way.
		var uriStep = this._getStepFromHash();
		if(stepNumber) {
			var stepPosition = stepNumber;
			if(uriStep != stepPosition) {
				var newHash = "#" + this.action + "&s=/steps/" + stepPosition;
				self.location.hash = newHash;
				//Since we changed the hash, the _hashChanged will pick it up and handle processing the step automatically
				//But, if it's embedded.. we need to call it manually since it's hooked to checkNavigationStatus by default.
				if(this.isEmbedded) {
					this._hashChanged();	
				} 
				return;
			}
		}

		// fall through to the super method
		this.inherited(arguments);
	},
	
}); // end of ApplicationWizard

})();