/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.ChangeSetEditor");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.InlineEditBox");
	dojo.require("jazz.util.html");
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationResource");
	
	dojo.require("jazz.app.ua.PageHoverHelp");
	dojo.require("jazz.app.ua.TextHoverHelp");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager");
	
	dojo.require("net.jazz.ajax.ui.PlatformUI");
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.UIUtils");
	var UIUtils = com.ibm.team.vvc.shared.web.ui.util.UIUtils;

	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
	var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget");

	dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "ChangeSetEditorMessages");
	var messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "ChangeSetEditorMessages");
	
	dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.context", "ConfigurationContextMessages");
	var configurationContextMessages = dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.context", "ConfigurationContextMessages");

	dojo.require("com.ibm.team.vvc.shared.web.ui.util.LinkToWorkItemUtil");
	var LinkToWorkItemUtil = com.ibm.team.vvc.shared.web.ui.util.LinkToWorkItemUtil;

	dojo.require("jazz.ui.StyledTable");
	
	dojo.require("jazz.ui.ResourceLink");
	var ResourceLink = jazz.ui.ResourceLink;
	
	dojo.require("com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils");
	var CLMUtils = 	com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer");
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.page.LinksMenuSection");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils");
	var InfoContentUtils = com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");
	var SecurityServiceUtils = com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils;
		
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
	var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory")
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory")
	var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;
	
	dojo.require("com.ibm.team.vvc.shared.oslc.web.utils.BaseClient");
	var BaseClient= com.ibm.team.vvc.shared.oslc.web.utils.BaseClient;
	
	var NON_BASE_SNAPSHOT = "noSnapshot";
	var VVC_ENDPOINT = "http://jazz.net/ns/vvc#endPoint";
	var VVC_INCOMPLETE = "http://jazz.net/ns/vvc#incomplete";
	var DCTERMS_TITLE = "http://purl.org/dc/terms/title";
	var VVC_SELECTS = "http://jazz.net/ns/vvc#selects";
	var PREDEFINED_DIMENSIONS = {"http://jazz.net/ns/vvc/ootb#purpose": messages.dimensionPurpose,
		"http://jazz.net/ns/vvc/ootb#changeSet": messages.dimensionChangeSet,
		"http://jazz.net/ns/vvc#timeOrder": messages.dimensionTimeOrder};
	
	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.ChangeSetEditor", [com.ibm.team.vvc.server.core.ui.internal.page._EditorWidget, dijit._Templated], {

		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/page/templates/ChangeSetEditor.html'),

		_editableTitle: null,
		_workspace: null,
		workItems : [],
		context: null,
		_changesetDetails: [],
		workspaceIconUrl: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/changeset.gif'),

		constructor: function() {
			this.messages = messages;
		},
	
		postCreate: function() {
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("ChangeSetEditor", this, "showPage");
			var onresizeHandle = dojo.connect(window, "onresize", this, this.onResize);
			this.notificationCenterNode.appendChild(new com.ibm.team.vvc.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController().domNode);
			this._initializeTabs();
		},
		
		_initializeTabs: function()
		{
			this._tabManager = new com.ibm.team.vvc.shared.web.ui.widgets.tab.TabManager();
			var class_selectedTab= "Selected";
			this._tabManager.registerTab(this._tabOverview, this.overview_content, class_selectedTab);
			this._tabManager.registerTab(this._tabDimensions, this.dimensions_content, class_selectedTab);
			this._tabManager.registerTab(this._tabResources, this.resources_content, class_selectedTab);
			this._tabManager.registerTab(this._tabWorkItems, this.workItems_content, class_selectedTab);
		},
		
		_initializeCSH:function()
		{
			if (this._ua != null)
				this._pageHeader.removeChild(this._ua.domNode);
			cshKey =  "com.ibm.team.vvc.server.core.page_ChangeSetEditor001";	
			this._ua = new jazz.app.ua.PageHoverHelp({uaKey: cshKey});
			this._pageHeader.appendChild(this._ua.domNode);
			this._ua.domNode.style.margin = "0px 0px 0px 5px";	
			
		},
		
	
		showPage: function() {
			this._renderPage();
		},
		
		_clearFields: function() {
			this.hideMessage();
		},
		
		 _getChangesetContextUri: function() {
			 var uri = ContextUtils.getRequestParmValue("changesetContext");
			 if (uri != null) {
				 uri = unescape(uri);
			 }
			 return uri;
		 }, 
			 
		_renderPage: function() {
			this.context = this._getChangesetContextUri();
			
			if (!this.context) {
				this.context = ContextUtils.getContextUri();
			}
			
			if (!this.context) {
				alert(messages.changesetEditorWithNoContext);
				error.log("No context for changeset editor");
				//cannot do anything when there is no changeset
				window.location.assign(VvcUtils.getVvcUri());
				return;
			}
			
			this._initBreadcrumbs();
			this._initializeCSH();
			this._clearFields();
			
			this._resetPage();
			this._checkRTCServer();
		},
		
		_resetPage: function() {
			var configuration = this.context == null ? null : this._getConfiguration(this.context);
			
			if (configuration.uri !== this.context) {
				this._workspace = configuration;
			} else {
				this._workspace = null;
			}

			var context1 = {
				context: this.context,
				changesetDetails: this._changesetDetails
			};
			var args = {
					headers: {
						"Accept": "application/json"
					},
					url: this.context + '?right_now='+new Date().getTime(),
					handleAs: "json",
					hasBody: false,
					error: dojo.hitch(this, function(responseerror) {
					}),
					load: dojo.hitch(context1, function(response, ioArgs) {
						for (key in this.changesetDetails) {
							delete this.changesetDetails[key];
						}
						
						var main = response[this.context];
						if (main[VVC_ENDPOINT] && main[VVC_ENDPOINT][0]) {
							this.changesetDetails[VVC_ENDPOINT] = main[VVC_ENDPOINT][0].value;
						}
						if (main[VVC_INCOMPLETE] && main[VVC_INCOMPLETE][0]) {
							this.changesetDetails[VVC_INCOMPLETE] = main[VVC_INCOMPLETE][0].value;
						}
						if (main[DCTERMS_TITLE] && main[DCTERMS_TITLE][0]) {
							this.changesetDetails[DCTERMS_TITLE] = main[DCTERMS_TITLE][0].value;
						}
						if (main[VVC_SELECTS]) {
							this.changesetDetails[VVC_SELECTS] = main[VVC_SELECTS];
						}
					})
				};

			var deferred1 = jazz.client.xhrGet(args);
			
			var canModifyChangesetDeferred = SecurityServiceUtils.canModifyTheChangeset(this.context);
			canModifyChangesetDeferred.addCallback(this, function (result) {
				this.canModifyChangeset = result;
			});
			
			var canAdminChangesetDeferred = SecurityServiceUtils.canAdministerTheChangeset(this.context);
			canAdminChangesetDeferred.addCallback(this, function (result) {
				this.canAdminChangeset = result;
			});
			
			var changesetControllingAreaDeferred;
			if (this._workspace) {
				changesetControllingAreaDeferred = SecurityServiceUtils.getChangesetControllingArea(this.context);
				changesetControllingAreaDeferred.addCallback(this, function (result) {
					this.changesetControllingArea = result;
				});
			} else {
				//the button should not appear at all when the configuration is unavailable, so string substitution will never occur (i.e. does not have to be localized)
				this.changesetControllingArea = "N/A";
			}
				
			var dl = changesetControllingAreaDeferred ? new dojo.DeferredList([deferred1, canModifyChangesetDeferred, canAdminChangesetDeferred, changesetControllingAreaDeferred]) : 
				new dojo.DeferredList([deferred1, canModifyChangesetDeferred, canAdminChangesetDeferred]);
			
			dl.then(dojo.hitch(this, function (param) {
				this.refresh();
			}), dojo.hitch(this, function(error) {
				this.showMessage(PageUtil.createXhrErrorMessage(deferred.ioArgs));
			}));
			
		},

		_checkRTCServer: function () {
			var form= [
			            {name: "internal", root: ["jfs:internal"], node: "#text", typeFunction: function(val){return Boolean(val);}},
			            {name: "rootService", root: ["jd:rootServices"],attribute: "rdf:resource"},
			            {name: "title",root: ["dc:title"],node: "#text"}
			        ];
			var cachedrootservices = {};

			 var d = jazz.client.xhrGet({
			    	url: VvcUtils.getVvcUri() + "/rootservices",
			    	handleAs: "text",
			    	load:  function(response){
			    		cachedrootservices = new com.ibm.team.vvc.shared.oslc.web.utils.RootServices(dojox.xml.DomParser.parse(response));
			    	},
			    	sync: true
			      });
			var friends= [];
			var friendsPath = cachedrootservices.getUri(RootServicesNamespaces.JD_1_0, "friends");
			var deferred= BaseClient.getResponse(friendsPath,{ path:["rdf:RDF","jd:Friend"], form: form}, {sync: true});
			
			deferred.addCallback(this, function(response){
	              friends= response; 
	          });
			 var bFound = false;
			 for(var index=0;index<friends.length; index++){
	                var current_rs= friends[index].rootService;
	                var ccmString = '/ccm/';

	                if (current_rs.toLowerCase().indexOf(ccmString) != -1){
	                	bFound = true;
	             }
			 }
		   if (!bFound)
			   {
			   ncFactory.createWarning    ({
					title: messages.ccmnotfound,
					solution: messages.ccmnotfoundsolution
				}).dispatch();
			   }
			
		},
		createEditableTitleNode: function(titleNode, title){
			if (this._editableTitle) {
				this._editableTitle.setValue(title);
			} else {
				titleNode.innerHTML = jazz.util.html.escape(title);
				this._editableTitle = new dijit.InlineEditBox({
					title: "",  //TODO: for now, you cannot edit: this.messages.clickToEdit, 
					autoSave: true, 
					width: "700px",
					noValueIndicator: this.getEditableTitleNodeDetails(), 
					editorParams: {maxLength: "60"},
					disabled: true, //TODO: for now, it is disabled because you cannot edit
					onFocus: dojo.hitch(this, this.hideMessage),
					onChange: dojo.hitch(this, this.onTitleChange)}, titleNode
				);
				//TODO: for now, you cannot edit: dojo.addClass(this._editableTitle.domNode, "vvc-editor-editIndicator");
	
				this._editableTitle.startup();
			}
			this._editableTitle.originalValue = this._editableTitle.getValue(title);
		},

		setTitleValue: function(value){
			if(this._editableTitle){
				this._editableTitle.set('value', value);
			}
		},

		getEditableTitleNodeDetails: function(){
			return "?";
		},
		
		refresh: function() {
			
			if (this._workspace && !this._workspace.isChangeset()) {
				alert(messages.changesetEditorOpenedOnContextThatIsNotAChangeset);
				error.log("Context for changeset editor is not valid: " + this._workspace.getSpaceName());
				//don't display changeset editor when context is invalid
				window.location.assign(VvcUtils.getVvcUri());
				return;
			}
			
			// create and set title
			var title = this._changesetDetails[DCTERMS_TITLE];
			this.createEditableTitleNode(this._titleNode, title);
			
			// set description text
			var url;
			if (this._workspace) {
				for (var key in this._workspace.data) {
					url = VvcUtils.getVvcUri() + "/web?contextUri=" + escape(key) + "#action=SnapshotEditor";
				}
			}
			
			var incomplete = this._changesetDetails[VVC_INCOMPLETE];
			
			if (this._changesetDetails[VVC_SELECTS] && !incomplete) {
				if (this._workspace) {
					this._completeness.innerHTML = messages.completeNotCommitted;
					dojo.byId("discardToolButton").style.display = "";
					dojo.byId("commitToolButton").style.display = "";
				} else {
					this._completeness.innerHTML = messages.completeCommitted;
					dojo.byId("discardToolButton").style.display = "none";
					dojo.byId("commitToolButton").style.display = "none";
				}
				dojo.byId("completeToolButton").style.display = "none";
			} else {
				this._completeness.innerHTML =  messages.incomplete; 
				dojo.byId("discardToolButton").style.display = "";
				dojo.byId("completeToolButton").style.display = "";
				dojo.byId("commitToolButton").style.display = "";
			}
			
			if (!this.canAdminChangeset) {
				this._discardButton.set("title", SecurityServiceUtils.getNoPermissionChangesetMessage(this.changesetControllingArea));
				this._commitButton.set("title", SecurityServiceUtils.getNoPermissionChangesetMessage(this.changesetControllingArea));
				
				this._discardButton.set("enabled", false);
				this._commitButton.set("enabled", false);
			}
			if (!this.canModifyChangeset && !this.canAdminChangeset) {
				this._completeButton.set("title", SecurityServiceUtils.getNoPermissionChangesetMessage(this.changesetControllingArea));
				this._completeButton.set("enabled", false);
			}
			
			if (url && this._workspace && this._workspace.getSpaceName()) {
				this._configurationSpace.innerHTML = (this._workspace.getSpaceName() ? this._workspace.getSpaceName() : "") + " <a href='" + url + "'>" + messages.openConfiguration + "</a>";
			}
			else {
				this._configurationSpace.innerHTML = messages.loadingConfigurationSpaceName;
			}
			
			if (this._changesetDetails[VVC_ENDPOINT]) {
				var args = {
						headers: {
							"Accept": "application/json"
						},
						url: this._changesetDetails[VVC_ENDPOINT],
						handleAs: "json",
						hasBody: false,
						error: dojo.hitch(this, function(err, args) {
							ncFactory.createXhrError({xhrError: err, ioArgs: args}).dispatch();
						}),
						load: dojo.hitch(this, function(response, ioArgs) {
							var endPoint = response[this._changesetDetails[VVC_ENDPOINT]];
							var space = endPoint["http://jazz.net/ns/vvc#space"];
							if (space[0] && space[0].value) {
								
								var context2 = {
									self: this,
									spaceUri: space[0].value,
									point: endPoint
								}
								
								var args2 = {
										headers: {
											"Accept": "application/json"
										},
										url: space[0].value,
										handleAs: "json",
										hasBody: false,
										error: dojo.hitch(context2, function(err, args) {
											ncFactory.createXhrError({xhrError: err, ioArgs: args}).dispatch();
										}),
										load: dojo.hitch(context2, function(response, ioArgs) {
											var space = response[this.spaceUri];
											if (space[DCTERMS_TITLE] && space[DCTERMS_TITLE][0]) {
												if (this.self._configurationSpace.innerHTML === messages.loadingConfigurationSpaceName) {
													this.self._configurationSpace.innerHTML = space[DCTERMS_TITLE][0].value;
												}
											} else {
												this.self._configurationSpace.innerHTML = messages.noConfigurationAvailable;
											}
											
											
											var dimensionTypes = space["http://jazz.net/ns/vvc#dimension"];
											if (dimensionTypes) {
												var dimensions = [];
												
												for (var d = 0; d < dimensionTypes.length; d++) {
													if (dimensionTypes[d].value) {
														var dimension = this.point[dimensionTypes[d].value];
														if (dimension && dimension[0] && dimension[0].value) {
															dimensions.push( { key: dimensionTypes[d].value, value: dimension[0].value, type: dimension[0].type} );
														}
													}
												}
												
												this.self._buildDimensionTab(dimensions);
											}
											
										})
									};					
								jazz.client.xhrGet(args2);
								
								
							} else {
								this.self._configurationSpace.innerHTML = messages.noConfigurationAvailable;
							}
						})
					};					
				jazz.client.xhrGet(args);
			}
			
			
			// build resource mappings viewer
			
			var container = dojo.byId("resources_viewer_div");
			if (this._resourceMappingTable) {
				container.removeChild(this._resourceMappingTable.domNode);
			}
			
			var contextUri = ContextUtils.getRequestParmValue("contextUri", window.location.href);
			contextUri = (contextUri && contextUri.length > 0) ? ("?configurationUri=" + contextUri) : "";
			
			this._resourceMappingTable = new com.ibm.team.vvc.server.core.ui.internal.page.ResourceMappingViewer({ context: this.context, _lazyStart: true, selectUri : this.context + "/resourceVersions" + contextUri, _showActions: false });
			this._resourceMappingTable.load(this);
			
			var deferredContext = {
				commitToolButton: dojo.byId("commitToolButton"),
				completeToolButton: dojo.byId("completeToolButton"),
				self: this
			}
			
		    container.appendChild(this._resourceMappingTable.domNode);			
			
			this._buildWorkItemsTab();
		    
		    this._tabManager.showActiveTab(this._tabOverview);
		},
		
		
		_obtainWorkItems: function() {
			var context1 = {
				workItems: this.workItems
			};
			var args = {
				headers: {
					"Content-Type": "application/x-oslc-common-link+xml",
					"Accept": "application/atom+json"
				},
				url: VvcUtils.getVvcUri() + "/changesetLinks?changeset=" + this.context + "&consumerUrl=" + VvcUtils.getVvcUri(),
				handleAs: "json",
				hasBody: false,
				error: dojo.hitch(context1, function(err, args) {
					ncFactory.createXhrError({xhrError: err, ioArgs: args}).dispatch();
				}),
				load: dojo.hitch(context1, function(response, ioArgs) {
					this.workItems.length = 0;
					
					for(var i = 0; i < response.length; i++){
						
						var workItem = {
								id: null,
								url: null,
								type: null,
								name: null,
								error: null
						};
						this.workItems.push(workItem);
						
						if (response[i].error) {
							workItem.error = response[i].error;
							workItem.id = "-";
						} else {
							var idString = "-";
							var indexOfSlash = response[i].target.lastIndexOf("/");
							if (indexOfSlash > 0 && indexOfSlash < response[i].target.length - 1) {
								workItem.id = response[i].target.substring(indexOfSlash + 1);
							}
							
							var context2 = {
								item: this.item,
								cell: this.cell,
								workItems: this.workItems,
								workItem: workItem
							};
							
							workItem.type = response[i].predicate;
							workItem.url = response[i].target;
							workItem.name = messages.loadingName;
							
						}
						
					}
						
					this.workItems.sort(CLMUtils.idSorter);
					
				})
			};
			return jazz.client.xhrGet(args);
		},
		
		_addIndividualWorkItems: function() {
			dojo.empty(this.container);
			
			var node = dojo.create("div");
			this.container.appendChild(node);
			
			
			var table = dojo.create("table");
			table.width = "100%";
			var tr = dojo.create("tr", { "class" : "header" } );
			
			var td = dojo.create("td");
			td.innerHTML = messages.workItems;
			tr.appendChild(td);
			
			table.appendChild(tr);
			
			this.container.appendChild(table);
			
			if (this.workItems.length == 0) {
				tr = dojo.create("tr");
				tr.innerHTML = messages.noWorkItems;
				table.appendChild(tr);
			}
			
			for (var i  = 0; i < this.workItems.length; i++) {
				tr = dojo.create("tr", { "class" : "entry" });
				
				var td = dojo.create("td");
				
				tr.appendChild(td);
				
				table.appendChild(tr);
				
				if (this.workItems[i].error) {
					td.innerHTML = this.workItems[i].error;
					continue;
				}
				
				
				var img = dojo.create("img");
				img.src = dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/list-arrow.gif');
				td.appendChild(img);

				img = dojo.create("img");
				td.appendChild(img);
				
				var a = dojo.create("a");
				a.href = this.workItems[i].url;
				a.title = this.workItems[i].id;
				a.innerHTML = this.workItems[i].id;
				td.appendChild(a);
				
				new ResourceLink({
					uri: a.href,
					label: a.title,
					iconNode: img
				}, a);
				
				td = dojo.create("td");
				node = dojo.create("div");
				node.align = "right";
				
				//<img class="action" align="centre" title="Delete" src="delete.gif" style="vertical-align: middle;"
				img = dojo.create("img", { "class" : "action" });
				img.src = dojo.moduleUrl('com.ibm.team.vvc.server.core', 'graphics/delete.gif');
				node.appendChild(img);
				td.appendChild(node);

                var deleteContext = {
                	tr: tr,
                	table: table,
                	uri: a.href,
                	context: this.context
                };
				
				dojo.connect(img,"onclick", deleteContext, function(e){
	                /*to prevent redirection*/
	                dojo.stopEvent(e);
	                
					var deferredDelete = jazz.client.xhrDelete({
						url: VvcUtils.getVvcUri() + "/changesetLinks?changeset=" + this.context +
	    					"&backlinkUrl=http%3A%2F%2Fopen-services.net%2Fns%2Fcm%23tracksChangeSet&target=" +
	    					this.uri + "&consumerUrl=" + VvcUtils.getVvcUri(),
						handleAs: "xml", //$NON-NLS-1$
						load: dojo.hitch(this, function(doc){
							this.table.removeChild(this.tr);
							
							if (this.table.children.length == 1) {
								var newtr = dojo.create("tr");
								newtr.innerHTML = messages.noWorkItems;
								this.table.appendChild(newtr);								
							}
						}),
						error: dojo.hitch(this, function(err, args){
							ncFactory.createXhrError({
								xhrError: err, 
								ioArgs: args,
								title: messages["unableToDeleteWorkItem"],
								description: messages["unableToDeleteWorkItem.explanation"],
								solution: messages["unableToDeleteWorkItem.useraction"]
							}).dispatch();
							return error;
						})
					});
	            });							
				tr.appendChild(td);
			}			
		},
		
		
		createMenuSection: function(scope, section){
			var theContext = {
					container: scope,
					context: this.context,
					workItems: this.workItems,
					_addIndividualWorkItems: this._addIndividualWorkItems,
					_obtainWorkItems: this._obtainWorkItems
				};
			
			var menuSection = new com.ibm.team.vvc.server.core.ui.internal.page.LinksMenuSection({
				postCreate: function(){
					this.inherited("postCreate", arguments);
					this.fillMenu(this.types);
				},
				addMenuAction: function(linkType){
					return {
						linkName: linkType.title,
						identifier: linkType.about,
						label: linkType.title,
						description: linkType.description
					};
				},
				fillMenuActions: function(linkTypes){
			        return linkTypes;
				},

	            parentWidget: section,
	            label: messages.addLink,
	            menuLabel: messages.addLink,
	            types: [{
	                linkName: messages.workItemLinkName,
	                identifier: "workitem",
	                label: messages.workItemLinkName,
	                description: messages.workItemLinkName,
	                iconUrl: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/add_workitem.gif'),
					action: dojo.hitch(theContext, function() {
						var deferredRefresh = new dojo.Deferred();
						LinkToWorkItemUtil.vvcLinkToWorkItemAction(this.context, deferredRefresh);
						deferredRefresh.addCallback(this, function() {
							var deferred = this._obtainWorkItems();
							deferred.addCallback(this, this._addIndividualWorkItems);
						});
					})
	            }]
	        });
	        return menuSection;
		},		
		
		
		_buildWorkItemsTab: function() {
			var container = this._workItemsContainerNode;
			
			dojo.empty(this._workItemsHeaderNode);
			dojo.empty(this._workItemsActionsNode);
			dojo.empty(container);
			
			var node = dojo.create("div");
			node.innerHTML = messages.loadingWorkItems;
			container.appendChild(node);
			
			var theContext = {
				container: container,
				context: this.context,
				workItems: this.workItems,
				_addIndividualWorkItems: this._addIndividualWorkItems,
				_obtainWorkItems: this._obtainWorkItems
			};
			
			var deferred = this._obtainWorkItems();
			deferred.addCallback(theContext, this._addIndividualWorkItems);
			
			var menuSectionNode = dojo.create("div");
			var menuSection = this.createMenuSection(container, menuSectionNode);
			this._workItemsActionsNode.appendChild(menuSection.domNode);
		},
		
		onDiscard: function() {
			InfoContentUtils.showQuestionDialog(messages.discardChangesetTitle, messages.discardChangesetMessage, messages.discardChangesetYes, messages.discardChangesetNo, dojo.hitch(this, function() {
				
				jazz.client.xhrDelete({
					handleAs: 'text',
					sync: true,
					url: this.context,
					content: {
						//nothing
					},
	
					load: dojo.hitch(this, function(response, ioArgs) {
						window.location.assign(VvcUtils.getVvcUri());
					}),
					
					error: dojo.hitch(this, function(err, args) {
						ncFactory.createXhrError({
							xhrError: err,
							ioArgs: args,
							title: dojo.string.substitute(configurationContextMessages["failedToDiscardChangeset"], [this._changesetDetails[DCTERMS_TITLE]]),
							description: configurationContextMessages["failedToDiscardChangeset.explanation"],
							solution: configurationContextMessages["failedToDiscardChangeset.useraction"]
						}).dispatch();
					})
				});
			}));
		},
		
		onCommit: function() {
			var url;
			for (var key in this._workspace.data) {
				//there is only one
				url = key;
			}
			
			if (url) {
				var headers = {
					"Content-Type" : "text/plain",
					"VvcChangeSetTargetWorkspace" : url
				};
				
				jazz.client.xhrPost({
					handleAs: 'text',
					headers: headers,
					sync: true,
					url: this.context,
					postData: JSON.stringify({ "action" : "COMMIT" }),
					load: dojo.hitch(this, function(response, ioArgs) {
						this._resetPage();
					}),
					error: dojo.hitch(this, function(err) {
						ncFactory.createXhrError({
							xhrError: err,
							title: dojo.string.substitute(configurationContextMessages["failedToCommitChangeset"], [this._changesetDetails[DCTERMS_TITLE]]),
							description: configurationContextMessages["failedToCommitChangeset.explanation"],
							solution: configurationContextMessages["failedToCommitChangeset.useraction"]
						}).dispatch();
					})
				});
			} else {
				ncFactory.createError({title: messages.unsuccessfullyCommitted}).dispatch();
			}
		},		
		
		onComplete: function() {
			jazz.client.xhrPost({
				handleAs: 'text',
				headers: {
					"Content-Type" : "text/plain"
				},
				sync: true,
				url: this.context,
				postData: JSON.stringify({ "action" : "COMPLETE" }),
				load: dojo.hitch(this, function(response, ioArgs) {
					this._resetPage();
				}),
				error: dojo.hitch(this, function(err, args) {
					ncFactory.createXhrError({
						xhrError: err,
						ioArgs: args,
						title: dojo.string.substitute(configurationContextMessages["failedToCompleteChangeset"], [this._changesetDetails[DCTERMS_TITLE]]),
						description: configurationContextMessages["failedToCompleteChangeset.explanation"],
						solution: configurationContextMessages["failedToCompleteChangeset.useraction"]
					}).dispatch();
				})
			});
		},
		
		_buildDimensionTab: function(dimensions) {
			// create table
			var columnData = [{ label: this.messages.dimensionTabNameColumnHeader }, { label: this.messages.dimensionTabValueColumnHeader }];
			var container = this._dimensionContainerNode;
			if (container && container.firstChild) {
				container.removeChild(container.firstChild);
			}
			
			// create table header
			var table = new jazz.ui.StyledTable({
				trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS,
				columns: columnData
			});
			table.domNode.style.width = "100%";
			container.appendChild(table.domNode);
			
			// Now add the rows
			if (dimensions && dimensions.length > 0) {
				var tr, td;
				for (var i = 0; i < dimensions.length; i++){
					tr = document.createElement("tr");
						
					// name column
					td = document.createElement("td");
					td.innerHTML = PREDEFINED_DIMENSIONS[dimensions[i].key] ? PREDEFINED_DIMENSIONS[dimensions[i].key] : dimensions[i].key;
					tr.appendChild(td);
					
					// value column
					td = document.createElement("td");
					td.innerHTML = jazz.util.html.escape(dimensions[i].value);
					
					//exceptionally format time order
					if ("http://jazz.net/ns/vvc#timeOrder" === dimensions[i].key) {
						try {
							td.innerHTML = new Date(Number(dimensions[i].value)).toLocaleString();
						} catch (ignoredException) {
							//ignore invalid date; simply display without special formatting
						}
					}
					
					var requestContext = {
						td: td,
						url: dimensions[i].value
					}
					
					if (dimensions[i].type === "uri") {
						var args = {
							headers: {
								"Accept": "application/json"
							},
							url: dimensions[i].value,
							handleAs: "json",
							hasBody: false,
//							error: dojo.hitch(requestContext, function(responseerror) {
//								don't handle this, leave default value
//								it is normal since not all urls are valid for json
//							}),
							load: dojo.hitch(requestContext, function(response, ioArgs) {
								if (response[this.url] && response[this.url][DCTERMS_TITLE] && response[this.url][DCTERMS_TITLE][0] && response[this.url][DCTERMS_TITLE][0].value) {
									this.td.innerHTML = jazz.util.html.escape(response[this.url][DCTERMS_TITLE][0].value);
								}
							})
						};					
						jazz.client.xhrGet(args);
					}
					
					tr.appendChild(td);
					
					table.tbody.appendChild(tr);
				}
			}
			
			return table;
		},
		
		////////////////////////////////////////////////
		// the following methods are not supported yet//
		////////////////////////////////////////////////
		
		onSave: function() {
			
		},
		
		onTitleChange: function(e){
			this.toggleSaveButton();
		},
		
		enableSaveButton: function()
		{
//TODO: editable title
//			var saveButton = dojo.byId("saveToolButton");
//			if (saveButton) {
//				saveButton.disabled = false;
//				var node = dojo.byId("dirty");
//				if (!node.firstChild) {
//					node.appendChild(dojo.doc.createTextNode(" *"));
//				}
//			}
		},
		
		disableSaveButton: function()
		{
//TODO: editable title
//			var saveButton = dojo.byId("saveToolButton");
//			if (saveButton) {
//				saveButton.disabled = true;
//				var node = dojo.byId("dirty");
//				if (node.firstChild) 
//					node.removeChild(node.firstChild);
//			}
		},
		
		toggleSaveButton: function()
		{
			if (this.isDirty())
				this.enableSaveButton();
			else
				this.disableSaveButton();
		},

		isDirty: function()
		{
//TODO: editable title
//			if (this._editableTitle && (this._editableTitle.value != this._editableTitle.originalValue))
//				return true;
			return false;
		}

	})   
})();
