/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

	dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.CompareConfigurations");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

	dojo.require("net.jazz.ajax.ui.PlatformUI");
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;

	dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	var vvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;
	
	dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
	var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;

	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.CompareConfigurations", [dijit._Widget, dijit._Templated], {

		templateString:
			"<div style='margin-left:1%'>" +
				"<table><tr><th colspan='2'><h1>Compare Configurations</h1></th></tr>" +
					"<tr><td>&nbsp;</td><td></td></tr>" +
					"<tr><td>Ancestor:</td><td>" +
						"<select id='ancestor'>" +
							"<option value='Configuration 1' selected>Configuration 1</option>" +
							"<option value='Configuration 2'>Configuration 2</option>" +
							"<option value='Configuration 3'>Configuration 3</option>" +
							"<option value='Configuration 4'>Configuration 4</option>" +
							"<option value='Configuration 5'>Configuration 5</option>" +
						"</select></td></tr>" +
					"<tr><td>Descendant:</td><td>" +
						"<select id='descendant'>" +
							"<option value='Configuration 1'>Configuration 1</option>" +
							"<option value='Configuration 2' selected>Configuration 2</option>" +
							"<option value='Configuration 3'>Configuration 3</option>" +
							"<option value='Configuration 4'>Configuration 4</option>" +
							"<option value='Configuration 5'>Configuration 5</option>" +
						"</select></td></tr>" +
					"<tr><td>Other Descendant:</td><td>" +
						"<select id='otherDescendant'>" +
							"<option value='NONE' >NONE</option>" +
							"<option value='Configuration 1'>Configuration 1</option>" +
							"<option value='Configuration 2'>Configuration 2</option>" +
							"<option value='Configuration 3' selected>Configuration 3</option>" +
							"<option value='Configuration 4'>Configuration 4</option>" +
							"<option value='Configuration 5'>Configuration 5</option>" +
						"</select></td></tr>" +
					"<tr><td>Merged:</td><td>" +
						"<select id='merged'>" +
							"<option value='NONE' >NONE</option>" +
							"<option value='Configuration 1'>Configuration 1</option>" +
							"<option value='Configuration 2'>Configuration 2</option>" +
							"<option value='Configuration 3'>Configuration 3</option>" +
							"<option value='Configuration 4' selected>Configuration 4</option>" +
							"<option value='Configuration 5'>Configuration 5</option>" +
						"</select></td></tr>" +
					"<tr><td>&nbsp;</td><td></td></tr>" +
					"<tr><td></td><td><input type='button' value='Start' dojoAttachPoint='_button'></td><td>" +
				"</table>" +
			"</div>",

		postCreate: function() {
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(vvcConstants.COMPARE_CONFIGURATIONS, this, "showPage");
			ActionRegistry.registerAction("CompareConfigurations", this, "showPage");
			dojo.connect(this._button, "onclick", this.performOperation);
		},

		showPage: function() {
		},

		performOperation: function() {
			var query = {};
			var select = dojo.byId("ancestor");
			var item = select.children[select.selectedIndex];
			query.ancestorUri = item.value;
			
			select = dojo.byId("descendant");
			item = select.children[select.selectedIndex];
			query.descendantUri = item.value;
			
			select = dojo.byId("otherDescendant");
			item = select.children[select.selectedIndex];
			if (item.value != "NONE") {
				query.otherDescendantUri = item.value;
			}
			
			select = dojo.byId("merged");
			item = select.children[select.selectedIndex];
			if (item.value != "NONE") {
				query.mergeUri = item.value;
			}
			
			query.redirectUri = encodeURIComponent(window.location.href);
			
			PageUtil.showPage(vvcConstants.EXPLORE_COMPARISON, dojo.objectToQuery(query));
		},

	})   
})();
