/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.CompareViewerWizardApplication");
dojo.require("net.jazz.ajax.ui._Application");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.StyledBox");

dojo.require("com.ibm.team.vvc.server.core.ui.internal.page.CompareViewerStep");
var CompareViewerStep = com.ibm.team.vvc.server.core.ui.internal.page.CompareViewerStep;

dojo.require("com.ibm.team.vvc.shared.web.ui.compare.EmbeddedWizard");
var EmbeddedWizard = com.ibm.team.vvc.shared.web.ui.compare.EmbeddedWizard;

dojo.require('com.ibm.team.vvc.shared.web.ui.context.ContextUtils');
var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.require("dojo.i18n");

/*######################################### */
/*These imports are required to invoke auth dialogs*/
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
/*######################################### */

dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "CompareViewerWizardApplicationMessages");

var TrimStyles = jazz.ui.StyledBox.TrimStyles;

dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.CompareViewerWizardApplication", net.jazz.ajax.ui._Application, {
	innerBoxTrim:  TrimStyles.EDITOR_YELLOW,
	
	steps: null,
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.page", "CompareViewerWizardApplicationMessages");

		var uri = ContextUtils.getRequestParmValue("provider");
		if (uri) {
			uri = decodeURIComponent(uri);
			var args = {
					compareProviderUri: uri
			};
			var step1 = new CompareViewerStep(args);
			
			this.steps= [step1];
		}
	},

	postCreate: function() {
		this._startApp();
	},
	
	_startApp: function () {
		document.body.style.background = "none";
		this._createUI();
		this.setName(this.messages.setupName);
		this.start();
		this.steps[0].start();
	},
	
	_createUI: function() {				
		this.content = dojo.create("div");
		this.content.style.height = "100%";
		
		var wizard = new EmbeddedWizard({
			fullPageContainer: this.content,
			steps: this.steps,
			hideTrim: true,
			showStepSummary: false,
		});
		
		net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode().appendChild(this.content);
		
		/*This is a safe check in order to avoid the wizard UI failure if error occurred */
		if(wizard.contentWidget){
			var contentWidget= wizard.contentWidget;
			if(dojo.isFunction(contentWidget.updateNavigationControls)){
				contentWidget.updateNavigationControls();				
			}
		}
	},
});

})();