/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.page.EditDimensionPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");

var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var TABLE_DATA = [
	{
		"name" : "name 1",
		"description" : "description 2",
		"type" : "dimension type1"
	}, 
	{
		"name" : "name 2",
		"description" : "description 2",
		"type" : "dimension type2"
	}
];

dojo.declare("com.ibm.team.vvc.server.core.ui.internal.page.EditDimensionPage", [dijit._Widget, dijit._Templated], {
  
	templateString: "<div><div><h1>Edit Dimension</h1></div><table width='80%' dojoAttachPoint='contentTable'></table></div>",
   
   postCreate: function(){
      // Register the page action
      var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
      ActionRegistry.registerAction("editDimension", this, "showPage");
      
      this._populateTable();
   },
   
   showPage: function() {
		// Remove all rows from the table
		this.contentTable.innerHTML = ""; 
		
		// Re-create the header row
		var newRow = dojo.create("tr");	
		dojo.create("th", {innerHTML: "Name"}, newRow);
		dojo.create("th", {innerHTML: "Description"}, newRow);
		dojo.create("th", {innerHTML: "Type"}, newRow);
		this.contentTable.appendChild(newRow);
		
		this._populateTable();
	},
	
	_populateTable: function() {
		for (var i = 0; i < TABLE_DATA.length; i++ ) {
			var newRow = dojo.create("tr");	
			
			dojo.create("td", {innerHTML: TABLE_DATA[i].name}, newRow);
			dojo.create("td", {innerHTML: TABLE_DATA[i].description}, newRow);
			dojo.create("td", {innerHTML: TABLE_DATA[i].type}, newRow);
			this.contentTable.appendChild(newRow);
		}
	}
})   
})();
