/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'stepTitle': "Finalize Configuration Management application",
	'step1Label': "Step 1:",
	'step1Title': "Initiate Finalization Process",
	'step2Label': "Step 2:",
	'step2Title': "View Progress",
	'finish': "Finish",
	'next': "Next",
	'startButtonLabel': "Finalize Application Setup",
	'description': "In order to finish the configuration of this application, there are a few operations that need to be completed. This step will provide feedback regarding the status of these operations. Once this step is complete, the application setup will be complete.",
	'startInstructions': "The finalization process is composed of two parts: Storing Consumer Key and Secret, and User Synchronization. To begin, click the button below.",
	'finalizePending': "Please wait while the application is being finalized. This may take a minute.",
	'allComplete': "The finalization process is complete. Click \"${0}\" to continue.",
	'noFinalizeNeeded' : "Finalization is not required or has already been completed for this application.",
	'operation1title': "Finish Registration",
	'operation1desc': "Now that this application's database has been configured, this operation will complete the application's registration with the Jazz Team Server.",
	'operation2title': "Perform User Synchronization",
	'operation2desc': "This operation will synchronize the user records stored in the Jazz Team Server into this application.",
	'operation3title': "Apply Internal License",
	'operation3desc': "The application uses a preauthorized user to communicate with the Jazz Team Server.  This user must have an internal license for the application to operate.",
	'operation4title': "Configure Storage",
	'operation4desc': "The application stores versioning data.  In order to store data, the application must configure storage.  This operation also creates the data necessary for the application to function.",	
	'disablingAdmin': "The finalization process is complete. ADMIN access on this application will be disabled and you will be automatically logged out of this application. Once setup is complete, you will need to log in to this application using the new admin user that you created on the Jazz Team Server.",
	'appNotRegistered': "This application needs to be registered with a Jazz Team Server to function correctly. To proceed, use the Setup Wizard located on the Jazz Team Server (For example: https://servername.domain.com:9443/jts/setup).",

	'finalizeError': "CRJAZ1850E Unable to save the consumer key and secret into the application's database. See details for more information.",
	'userSyncError': "CRJAZ1752E Unable to perform the User Sync operation. See details for more information.",
	'finalizeCheckError': "CRJAZ1787E An error occurred while trying to determine if the Finalize operation is required for this application.",
	
	'operationError': "CRMVC0001E This operation did not complete because of a problem on the Jazz Team Server. ",  
	'operationError.explanation': "An error occurred while trying to complete this operation during the setup of the application.", 
	'operationError.useraction': "For more information, see the error message at the top of this page.", 

	'licenseError': "CRMVC0002E The internal license for the application cannot be applied. ", 
	'licenseError.explanation': "An error occurred when applying the internal license. ",  
	'licenseError.useraction': "Verify that you have permission to complete this operation. For more information, see the error message at the top of this page.", 

	'createStorageError': "CRMVC0003E The storage areas cannot be created.", 
	'createStorageError.explanation': "The storage areas store configuration data. Failure to create the storage areas could occur for various reasons.", 
	'createStorageError.useraction': "For more information, see the error message at the top of this page.", 
	
})	
