/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
	dojo.provide("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter.VvcNotificationCenter");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter.VvcNotificationCenterMessageContent");
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationObject");
	dojo.require("com.ibm.team.vvc.shared.web.ui.gc.VvcGarbageCollector");
	dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.VvcNotificationConstants");
	var ncConstants = com.ibm.team.vvc.shared.web.ui.notifications.VvcNotificationConstants;
	
	dojo.require("jazz.ui.MessageBox");
	
	dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter", "VvcNotificationCenterMessages");
	
	dojo.declare("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter.VvcNotificationCenter",  [dijit._Widget, dijit._Templated], {
				
			templatePath: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'ui/notifications/notificationCenter/templates/VvcNotificationCenter.html'),
			messages: dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter", "VvcNotificationCenterMessages"),
						
			// garbage collector
			gc: null,
			
			channels: null,
			
			messageBox: null,
			messageContent: null,
			pagination: null,
			isHidden: null,
				
			constructor: function(args){
				this.gc = new com.ibm.team.vvc.shared.web.ui.gc.VvcGarbageCollector();
				
				this.channels = [];
				if(args){
					if(args.channels){
						// Expects an array
						this.addChannels(args.channels);
					}
				}
			},
			
			
			destroy: function(){
				this.gc.destroy();
			},
			
			addChannel: function(channel){
				this.gc.disconnects(dojo.subscribe(channel, dojo.hitch(this, this.addNotification)));
				this.channels.push(channel);
			},
			
			addChannels: function(channels){
				dojo.forEach(channels, dojo.hitch(this, this.addChannel));
			},
			
			addNotification: function(notification){		
				this.showNotification(notification);
				
				notification.addOnClose(dojo.hitch(this, function(){
					if(this.messageContent){
						var notifications = this.messageContent.getNotifications();
						var index = dojo.indexOf(notifications, notification);
						if(index || index === 0){
							this.messageContent.hideNotification(index);
						}
					}
				}));
			},
			
			showNotification: function(notification){		
				if(!this.messageContent){
					this.messageContent = new com.ibm.team.vvc.shared.web.ui.notifications.notificationCenter.VvcNotificationCenterMessageContent();
					var handle = dojo.connect(this.messageContent, "hideNotification", dojo.hitch(this, function(){
						if(this.messageContent && this.messageContent.getLength() <= 0){
							this.messageBox.hideMessage();
							dojo.destroy(this.messageContent);
							dojo.destroy(this.messageBox);
							this.messageBox = null;
							this.messageContent = null;
							this.isVisible = false;
							dojo.disconnect(handle);
						}
					}));
				}
												
				if(!this.messageBox){
					this.messageBox = new jazz.ui.MessageBox();
					this.vvcNotificationCenterNode.appendChild(this.messageBox.domNode);
					this.isVisible = false;
				}
								
				if(!this.isVisible){
					this.messageBox.showMessage({
						type: notification.type,
						summary: this.messageContent.domNode
					});
					this.isVisible = true;
				}
				this.messageContent.addNotification(notification);
			}
	}); // end declare	
})(); // end object