/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.ChangesetResource");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
	var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.VvcObject");

	dojo.declare("com.ibm.team.vvc.shared.core.ui.objects.ChangesetResource",
			com.ibm.team.vvc.shared.core.ui.objects.VvcObject, {
		
		getFrontServiceId: function() {
			return "changesets";
		},
		
		getCreated: function() {
			return this.getProperty(Constants.CREATED);
		},

		getCreator: function() {
			return this.getProperty(Constants.CREATOR);
		},
		
		getState: function() {
			return this.getProperty(Constants.STATE);
		},
		
		getCompletionTime: function() {
			return this.getProperty(Constants.COMPLETION_TIME);
		},
		
		getTitle: function() {
			return this.getProperty(Constants.TITLE);
		},
		
		loadByConfiguration: function(configuration)
		{
			var uri = VvcUtils.getVvcUri() + "/changesets/getByConfigurationUri?configurationUri="+configuration.uri;
			this.result = null;
			var args = {
					url: uri, 
					headers: {
						"Accept" : "application/json;application/rdf+json;text/rdf+json;text/json",
					},
					sync: true,
					handleAs: "json",
					load: dojo.hitch(this, function(response, ioArgs) {
						if (response) {
							for (var uri in response) {
								this.uri = uri;
								this.properties = response[uri];
								break;
							}
						}
						return this;				
					}),
					error: dojo.hitch(this, this.onError),
					failOk: true
			};
			
			return jazz.client.xhrGet(args);	
		},
		
		onError: function(response, ioArgs) {
			alert("Failed to load resource '"+ioArgs.args.headers.vvc_servicePath+"'");
			console.log("Failed to load resource '"+ioArgs.args.headers.vvc_servicePath+"'...Invalid Response Status("+ioArgs.xhr.status+"): "+ response.message);
		},
	});
})();