/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.CompareProvider");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.VvcObject");
	
	dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");

	dojo.declare("com.ibm.team.vvc.shared.core.ui.objects.CompareProvider",
			com.ibm.team.vvc.shared.core.ui.objects.VvcObject, {		

		constructor: function(properties) {
			this.properties = properties;
		},
		
		getFrontServiceId: function() {
			return null;
		},

		canProvideWebFunctionality: function() {
			return this.getProperty(Constants.DELIVER_COMPARE_PROVIDER_CAN_PROVIDE_WEB_FUNCTIONALITY);
		},

		getTitle: function() {
			return this.getProperty(Constants.TITLE);
		},

		getCompareWebUri: function() {
			return this.getProperty(Constants.DELIVER_COMPARE_PROVIDER_COMPARE_WEB_URI);
		},
		
		hasSeparateMergeProvider: function() {
			return this.getProperty(Constants.DELIVER_COMPARE_PROVIDER_HAS_SEPARATE_MERGE_PROVIDER);
		},
		
		getMergeWebUri: function() {
			return this.getProperty(Constants.DELIVER_COMPARE_PROVIDER_MERGE_WEB_URI);
		},
		
		getUri: function() {
			return this.getProperty(Constants.DELIVER_COMPARE_PROVIDER_URI);
		},
		
		
	});
})();