/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.DeliverSession");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.VvcObject");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.DeliverableChangeset");
	var DeliverableChangeset = com.ibm.team.vvc.shared.core.ui.objects.DeliverableChangeset;

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.CompareProvider");
	var CompareProvider = com.ibm.team.vvc.shared.core.ui.objects.CompareProvider;

	dojo.declare("com.ibm.team.vvc.shared.core.ui.objects.DeliverSession",
			com.ibm.team.vvc.shared.core.ui.objects.VvcObject, {		

		getFrontServiceId: function() {
			return "deliver";
		},
		
		getState: function() {
			return this.getProperty(Constants.DELIVER_STATE);
		},

		setState: function(value) {
			return this.setProperty(Constants.DELIVER_STATE, value);
		},
		
		getProviders: function() {
			var providers = this.getProperty(Constants.DELIVER_COMPARE_PROVIDER);
			var retVal = [];
			
			if (providers) {
				if (!(providers instanceof Array)) {
					providers = [providers];
				}
				
				for (var i = 0; i < providers.length; i++) {
					var provider = new CompareProvider(providers[i]);
					retVal.push(provider);
				}
			}
			
			return retVal;
		},
		
		getExpirationDate: function() {
			return this.getProperty(Constants.DELIVER_EXPIRATION_DATE);
		},

		setExpirationDate: function(value) {
			return this.setProperty(Constants.DELIVER_EXPIRATION_DATE, value);
		},
		
		getCreatedAt: function() {
			return this.getProperty(Constants.DELIVER_CREATED_DATE);
		},
		
		getRefererUrl: function() {
			return this.getProperty(Constants.DELIVER_REFERER);
		},

		setRefererUrl: function(value) {
			return this.setProperty(Constants.DELIVER_REFERER, value);
		},
		
		getSourceUri: function() {
			return this.getProperty(Constants.DELIVER_SOURCE);
		},

		setSourceUri: function(value) {
			return this.setProperty(Constants.DELIVER_SOURCE, value);
		},
		
		getTargetUri: function() {
			return this.getProperty(Constants.DELIVER_TARGET);
		},

		setTargetUri: function(value) {
			return this.setProperty(Constants.DELIVER_TARGET, value);
		},
		
		getSelectedChangesets: function() {
			return this.getProperty(Constants.DELIVER_SELECTED_CHANGESETS);
		},

		setSelectedChangesets: function(value) {
			return this.setPropertyArray(Constants.DELIVER_SELECTED_CHANGESETS, value, "uri");
		},
		
		isApplyCompleteChangesetsOnly: function() {
			var value = this.getProperty(Constants.DELIVER_APPLY_COMPLETED_CHANGESETS_ONLY);
			if (value === "true" || value === true) {
				return true;
			} else {
				return false;
			}
		},

		setApplyCompleteChangesetsOnly: function(value) {
			var valueToSend = "false";
			if (value) {
				valueToSend = "true";
			}
			
			return this.setProperty(Constants.DELIVER_APPLY_COMPLETED_CHANGESETS_ONLY, valueToSend, "literal", Constants.XMLS_BOOLEAN);
		},
		
		isCompareOnly: function() {
			var value = this.getProperty(Constants.DELIVER_COMPARE_ONLY);
			if (value === "true" || value === true) {
				return true;
			} else {
				return false;
			}
		},

		setCompareOnly: function(value) {
			var valueToSend = "false";
			if (value) {
				valueToSend = "true";
			}
			
			return this.setProperty(Constants.DELIVER_COMPARE_ONLY, valueToSend, "literal", Constants.XMLS_BOOLEAN);
		},
		
		getResolvedConflicts: function() {
			return this.getProperty(Constants.DELIVER_RESOLVED_CONFLICTS);
		},

		setResolvedConflicts: function(value) {
			return this.setProperty(Constants.DELIVER_RESOLVED_CONFLICTS, value);
		},
		
		getAcceptedOutgoingChanges: function() {
			return this.getProperty(Constants.DELIVER_ACCEPTED_OUTGOING);
		},

		setAcceptedOutgoingChanges: function(value) {
			return this.setProperty(Constants.DELIVER_ACCEPTED_OUTGOING, value);
		},
		
		isCommitChangeSet: function() {
			var value = this.getProperty(Constants.COMMIT_CHANGE_SET);
			if (value === "true" || value === true) {
				return true;
			} else {
				return false;
			}
		},

		setCommitChangeSet: function(value) {
			var valueToSend = "false";
			if (value) {
				valueToSend = "true";
			}
			
			return this.setProperty(Constants.COMMIT_CHANGE_SET, valueToSend, "literal", Constants.XMLS_BOOLEAN);
		},
		
		getDeliverableChangesets: function() {
			var changesets = this.getProperty(Constants.DELIVER_DELIVERABLE_CHANGESETS);
			var retVal = [];
			
			if (changesets) {
				if (!(changesets instanceof Array)) {
					changesets = [changesets];
				}
				
				for (var i = 0; i < changesets.length; i++) {
					var changeset = new DeliverableChangeset(changesets[i]);
					retVal.push(changeset);
				}
			}
			
			return retVal;
		},		
		
	});
})();