/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {	
dojo.provide("com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils");
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");
dojo.require("com.ibm.team.vvc.shared.oslc.web.utils.RootServices");
dojo.require("jazz.client.xhr");
dojo.require("net.jazz.ajax.contextRoot");

dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

var providers= ["rmServiceProviders","amServiceProviders", "cmServiceProviders","qmServiceProviders", "rmps:linkServiceProviderCatalogs"];

var UIHelper= com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;

var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

	com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils = {
			
		doOSLCQuery: function(results, changesetUri, callback) {
			
	        var theDeferreds = [];

			for (var i = 0; i < results.length; i++) {
				if (results[i].res) {
            		var deferredServices = jazz.client.xhrGet({
            			url: results[i].res,
            			headers: {
            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML
            			},
            			handleAs: "xml"
            		});
            		theDeferreds.push(deferredServices);
				}
			}
			
	        var dl = new dojo.DeferredList(theDeferreds);
	        
	        var queryUrls = [];
	        
	        /*all(theDeferreds)*/ dl.then(dojo.hitch(this, function(result, ioArgs) {
	        	var secondDeferreds = [];

                //Example: queryUrl + "?oslc.prefix=oslc_cm=<http://open-services.net/ns/cm%23>&oslc.where=oslc_cm:tracksChangeSet=<" + changesetUri + ">";
	        	var urlArgs = dojo.objectToQuery({
	        		"oslc.prefix" : "oslc_cm=<http://open-services.net/ns/cm#>",
	        		"oslc.where" : "oslc_cm:tracksChangeSet=<" + changesetUri + ">"
	        	});
	        	
	        	for (var i = 0; i < result.length; i++) {
	        		
	        		if (result[i][0]) {
			        	var serviceDescriptor = UIHelper.getNode(this._getChildNodes(result[i][1]), "ServiceDescriptor", ProcessConstants.NAMESPACE_OSLC_CM);
			        	
			        	if (serviceDescriptor) {
				        	var changeRequests = UIHelper.getNode(this._getChildNodes(serviceDescriptor), "changeRequests", ProcessConstants.NAMESPACE_OSLC_CM);
				        	
				        	if (changeRequests) {
					        	var simpleQuery = UIHelper.getNode(this._getChildNodes(changeRequests), "simpleQuery", ProcessConstants.NAMESPACE_OSLC_CM);

					        	if (simpleQuery) {
						        	var url = UIHelper.getNode(this._getChildNodes(simpleQuery), "url", ProcessConstants.NAMESPACE_OSLC_CM);

						        	if (url) {
							        	var queryUrl = url.textContent ? url.textContent : url.text; //IE8
							        	queryUrls.push(queryUrl);
							        	
							        	var deferredOSLCQuery = jazz.client.xhrGet({
					            			url: queryUrl + "?" + urlArgs,
					            			headers: {
					            				"accept": "application/rdf+xml"
					            			},
					            			handleAs: "xml"
					            		});
					            		secondDeferreds.push(deferredOSLCQuery);
						        		
						        	}
					        		
					        	}
				        		
				        	}
			        		
			        	}
			        	
		        	} /*else { Notifications from the banner are not supported yet
		        		if (theDeferreds.length >= i && theDeferreds[i] && theDeferreds[i].ioArgs) {
			        		VvcNotificationFactory.createXhrError(theDeferreds[i].ioArgs);
		        		}
		        	}*/
	        			
        		}
	        		
	        	
        		var dl2 = new dojo.DeferredList(secondDeferreds);
        		
    	        /*all(secondDeferreds)*/ dl2.then(dojo.hitch(this, function(result) {
    	        	var ccmItems = [];

    	        	for (var i = 0; i < result.length; i++) {
    	        		
    	        		if (result[i][0]) {
            		        var rdfNode = UIHelper.getNode(this._getChildNodes(result[i][1]), "RDF", ProcessConstants.NAMESPACE_RDF);
            		        
            		        if (rdfNode) {
            		            var rdfDescriptions = UIHelper.getNodes(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);
            		            
            		            if (rdfDescriptions) {
                		            for (var j = 0; j < rdfDescriptions.length; j++) {
                		            	var rdfDescription = rdfDescriptions[j];
                		            	
                		            	var about = rdfDescription.getAttribute("rdf:about");
                                		//use this approximate check instead if worried about performance: about.indexOf(urlArgs) < 0
                                		if (about && dojo.indexOf(queryUrls, about) >= 0) {
                        		            var members = UIHelper.getNodes(this._getChildNodes(rdfDescription), "member", "http://www.w3.org/2000/01/rdf-schema#");

                        		            for (var k = 0; k < members.length; k++) {
                        		            	var member = members[k];
                            		            if (member) {
                                		            var resUrl = member.getAttribute("rdf:resource");
                                            		
                                            		ccmItems.push( { target: resUrl } );
                            		            }
                        		            	
                        		            }
                                		}
                		            	
                		            }
            		            }
            		        }
    	        			
    	        		} /* else { Notifications from the banner are not supported yet
    		        		if (secondDeferreds.length >= i && secondDeferreds[i] && secondDeferreds[i].ioArgs) {
			        			VvcNotificationFactory.createXhrError(secondDeferreds[i].ioArgs);
    		        		}
    	        		}*/
    	        		
    	        	}
    	        	
    	        	callback.resolve(ccmItems);
    	        	
    	        }));
	        }));
			
			
		},
			
		idSorter: function(first,second){
			var one = first.id, two = second.id;
			var oneNumber = Number(one), twoNumber = Number(two);
			if (!isNaN(oneNumber) && !isNaN(twoNumber)) {
				return oneNumber - twoNumber; 
			} else {
				return (one.toUpperCase() < two.toUpperCase()) ? -1 : 1;
			}
		},

	    _getChildNodes: function(source) {
	        if (dojo.isArray(source)) {
	            return source;
	        }

	        if (dojo.isIE > 8) {
	            var childNodes = [];
	            var node = source.firstChild;
	            while (node) {
	                childNodes.push(node);
	                node = node.nextSibling;
	            }
	            return childNodes;
	        }

	        return source.childNodes;
	    },
	    
	    extractTitle: function(doc) {
	        var rdfNode = UIHelper.getNode(this._getChildNodes(doc), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
	        
	        if (rdfNode) {
	            var rdfDescription = UIHelper.getNode(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);
	            
	            if (rdfDescription) {
	                var title = UIHelper.getNode(this._getChildNodes(rdfDescription), "title", ProcessConstants.NAMESPACE_DC);
	                
	                if (title) {
	                    return title.textContent ? title.textContent : title.text; //IE8
	                }
	            }
	        }	
	    },
	    
	    getServiceProviders: function(resourceUri){
	        var args = {
	            url: net.jazz.ajax._contextRoot + "/linkServiceProviders?" + dojo.objectToQuery({"resourceUri": resourceUri?resourceUri: ""}),
	            handleAs: "xml",
	            headers: {"X-ibm-rmps-internal": "true"},
	            load: function(response, ioArgs){
	                var serversDict= [];
	                for(var index=0;index<providers.length;index++){
	                    var provider= providers[index];
	                    var entries = response.getElementsByTagName(provider);
	                    if(entries){
	                        var entriesLength= entries.length;
		                    if (entriesLength > 0) {
		                        for (var i = 0; i < entriesLength; i++) {
		                            var catalog = entries[i].getAttribute("rdf:resource");
		                            if(!catalog){
		                                continue;
		                            }
		                            
		                            var title = entries[i].getAttribute("dcterms:title");
		                            if(!title){
		                                continue;
		                            }
		                            
		                            serversDict[title]= catalog;
		                        }
		                    }
	                    }
	                }
	                return serversDict;
	            }
	        };
	        return jazz.client.xhrGet(args);
	    },
	    
	    getVVCLinks: function(callback) {
	    	
	    	var context = {
	    		callback: callback
	    	};
	    	
	    	var deferredList = new dojo.Deferred();
	    	this.authenticate(deferredList);
	    	deferredList.addCallback(context, function(result){

	    		var outerProjectLinkObject = [];
	    		
	    		for (var i = 0; i < result.length; i++) {
	    			
		    		//expected undefined for unsupported types of projects
	    			if (result[i][1]) {
	    				
	    				for (var j = 0; j < result[i][1].length; j++) {
	    		    		var vvcLinks = [];
	    		    		
	    		    		var dojoUrl = new dojo._Url(result[i][1][j].details);
		    				var linkObj = {
	    						details: dojoUrl,
	    						isImplicit: false,
	    						presentationLabel: result[i][1][j].title + " (" + dojoUrl.authority + ")",
	    						serviceUrl: result[i][1][j].res,
	    						title: result[i][1][j].title
		    				};
		    				vvcLinks.push(linkObj);
		    				
				    		var projectLinkObject = {
				    			linkType: "architects",
				    			serviceProviders: vvcLinks
				    		};
				    		
				    		outerProjectLinkObject.push(projectLinkObject);
				    		
	    				}
	    				
	    			}
	    			
	    			
	    		}
	    		
	    		this.callback.resolve(outerProjectLinkObject);
	    	});
	    },
	    
	    /*Callback being null or not is the caller responsibility, so, we do not check for is. callback is not optional in this method */
	    getProjectLinks: function(projectAreaUri, contextForImplicitLinks, data, acceptableLinkTypes, callback) {
	        var dpls = [];
	        if (data) {
	            if (dojo.isArray(data)) {
	                for (var u = 0; u < data.length; u++) {
	                    dpls.push(this._getExplicitProjectLinks(projectAreaUri, data[u]));
	                }
	            } else {
	                dpls.push(this._getExplicitProjectLinks(projectAreaUri, data));
	            }
	            if (contextForImplicitLinks) {
		            dpls.push(this._getImplicitProjectLinks(contextForImplicitLinks)); //$NON-NLS-1$
	            }
	        } else {
	            dpls.push(this._getExplicitProjectLinks(projectAreaUri));
	            if (contextForImplicitLinks) {
	            	dpls.push(this._getImplicitProjectLinks(contextForImplicitLinks)); //$NON-NLS-1$
	            }
	        }

	        var dl = new dojo.DeferredList(dpls);
	        dl.then(dojo.hitch(this, function(result) {
	            var linkNodes = result[0][1];
	            for (var r = 1; r < result.length; r++) {
	                linkNodes = linkNodes.concat(result[r][1]);
	            }
	            if (!linkNodes) {
	                return;
	            }

	            var processed = {};
	            var projectLinks = [];
	            var deferreds = [];
	            for (var index = 0; index < linkNodes.length; index++) {
	                var current = linkNodes[index];
	                var plNodes = this._getChildNodes(current);

	                var linkTypeNode = UIHelper.getNode(plNodes, "link-type", ProcessConstants.NAMESPACE_JP);
	                var linkType = linkTypeNode.textContent ? linkTypeNode.textContent : linkTypeNode.text;
	                var jpUrlNode = UIHelper.getNode(plNodes, "url", ProcessConstants.NAMESPACE_JP);
	                var jpUrl = jpUrlNode.textContent ? jpUrlNode.textContent : jpUrlNode.text;
	                var isImplicit = (jpUrl && jpUrl.substring(jpUrl.lastIndexOf("/") + 1, jpUrl.length) === "implicit");
	                var projectLink = {
	                    url: jpUrl,
	                    linkType: linkType,
	                    serviceProviders : []
	                };

	                var serviceProviderNodes = UIHelper.getNodes(plNodes, "ServiceProvider", ProcessConstants.NAMESPACE_OSLC);
	                
	                for (var sp = 0; sp < serviceProviderNodes.length; sp++) {
	                    var spNodes = this._getChildNodes(serviceProviderNodes[sp]);
	                    var servicesNode = UIHelper.getNode(spNodes, "services", ProcessConstants.NAMESPACE_OSLC);
	                    var serviceUrl = servicesNode.getAttribute("rdf:resource");
	                    var servicesPath = new dojo._Url(serviceUrl).path;
	                    var applicationType = servicesPath.substring(0, servicesPath.indexOf("/", 1));

	                    var details = UIHelper.getNode(spNodes, "details", ProcessConstants.NAMESPACE_OSLC);
	                    var projectUrl = new dojo._Url(details.getAttribute("rdf:resource"));

	                    var titleNode = UIHelper.getNode(spNodes, ProcessConstants.XMLELEMENT_TITLE, ProcessConstants.NAMESPACE_DC);
	                    var projectName = titleNode.textContent ? titleNode.textContent : titleNode.text ? titleNode.text : "";
	                    var presentationLabel = projectName + " (" + applicationType + ": " + projectUrl.authority + ")";
	                    
	                    
	                    if (acceptableLinkTypes) {
		                    var rootservices = projectUrl.scheme + "://" + projectUrl.authority + applicationType + "/rootservices";

	                        var def = new dojo.Deferred(function(reason){});
	                		def.index = index;
	                		deferreds.push(def);

		            		var context = {
			            			 def: def,
			            			 projectName: projectName,
			            			 serviceUrl: serviceUrl,
			            			 projectUrl: projectUrl,
			            			 presentationLabel: presentationLabel,
			            			 isImplicit: isImplicit,
			            			 projectLink: projectLink,
			            			 self: this
			            		};
	                		
		            		var deferredRootservices = jazz.client.xhrGet({
		            			url: rootservices,
		            			headers: {
		            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
		            			},
		            			handleAs: "xml", //$NON-NLS-1$
		            			error: dojo.hitch(context, function(error){
		            				//this is perfectly fine; the server may be
		            				//down
		            				//make sure to resolve the def in order not
		            				//to prevent this from completing and
		            				//successful servers from being added to the
		            				//result
		            				context.def.resolve();
		            				console.error(error);
		            			})
		            		});
		            		
		            		deferredRootservices.addCallback(context, function(result){
		            			
		            			var d = this.def;
		            			
		                        var descriptionNode = UIHelper.getNode(this.self._getChildNodes(result), "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
		                        
			                        if (descriptionNode) {
			                        	
			                        var provider = UIHelper.getNode(this.self._getChildNodes(descriptionNode), "cmServiceProviders", ProcessConstants.NAMESPACE_OSLC_CM);
			                        
			                        if (provider) {
			                        	
			                        var res = provider.getAttribute("rdf:resource");
			                        
			                        if (res) {
			                    		var deferredCatalog = jazz.client.xhrGet({
			                    			url: res,
			                    			headers: {
			                    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
			                    				"OSLC-Core-Version": "2.0",
			                    				"X-rmps-internal": "true"
			                    			},
			                    			handleAs: "xml", //$NON-NLS-1$
			                    			error: dojo.hitch(this, function(error){
			                    				console.error(error);
			                    				return error;
			                    			})
			                    		});
		
			                    		deferredCatalog.addCallback(this, function(result){
			                    			
			                    			var def = this.def;
			                    			
			                                var rdfNode = UIHelper.getNode(this.self._getChildNodes(result), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
			
			                                
			                                if (rdfNode) {
				                                var catalog = UIHelper.getNode(this.self._getChildNodes(rdfNode), "ServiceProviderCatalog", ProcessConstants.NAMESPACE_OSLC_CORE);
				                                
				                                if (catalog) {
					                                var provider = UIHelper.getNode(this.self._getChildNodes(catalog), "domain", ProcessConstants.NAMESPACE_OSLC_CORE);
					                                
					                                if (provider) {
						                                var res = provider.getAttribute("rdf:resource");

						                                if (dojo.indexOf(acceptableLinkTypes, res) >= 0) {
						                                	//add this link type since it is one of the acceptable ones, for example: http://open-services.net/ns/cm#
						                                	
						                                    if (processed[this.presentationLabel]) {
						                                        /* 19030: Duplicated projects appear in link provider selection dialog
						                                         * TEMP solution till we support linking based on link types. 
						                                         */
						                                        if (this.isImplicit) {
						                                            var indexes = processed[this.presentationLabel];
						                                            var serviceProvider = projectLinks[indexes[0]].serviceProviders[indexes[1]];
						                                            serviceProvider.isImplicit = true;
						                                        }
						                                        //continue;
						                                        def.resolve();
						                                        return;
						                                    }
		
						                                    this.projectLink.serviceProviders.push({
						                                        title: this.projectName,
						                                        serviceUrl: this.serviceUrl,
						                                        details: this.projectUrl,
						                                        presentationLabel: this.presentationLabel,
						                                        isImplicit: this.isImplicit                        
						                                    });
		
						                                    processed[this.presentationLabel] = [ projectLinks.length, this.projectLink.serviceProviders.length - 1 ];
						                                    
						        	                        if (this.projectLink.serviceProviders.length > 0) {
						        	                            projectLinks.push(this.projectLink);
						        	                        }
						                                	
						                                } else {
						                                	//don't bother adding
						                                }
						                                
						                                def.resolve(this.projectLink);
					                                	
					                                } else {
					                                	//no provider
					                                	def.resolve();
					                                }
				                                } else {
				                                	//no catalog
				                                	def.resolve();
				                                }
				                            	
			                                } else {
			                                	//no rdfnode
			                                	def.resolve();
			                                }
			                            });
			                        } else {
			                        	//no res
			                        	d.resolve();
			                        }
			                        } else {
			                        	//no provider
			                        	d.resolve();
			                        }
			            		} else {
			            			//no DescriptionNode
			            			d.resolve();
			            		}

		
		                    });
	                    
	                    } else {

	                        if (processed[presentationLabel]) {
	                            /* 19030: Duplicated projects appear in link provider selection dialog
	                             * TEMP solution till we support linking based on link types. 
	                             */
	                            if (isImplicit) {
	                                var indexes = processed[presentationLabel];
	                                var serviceProvider = projectLinks[indexes[0]].serviceProviders[indexes[1]];
	                                serviceProvider.isImplicit = true;
	                            }
	                            continue;
	                        }

	                        projectLink.serviceProviders.push({
	                            title: projectName,
	                            serviceUrl: serviceUrl,
	                            details: projectUrl,
	                            presentationLabel: presentationLabel,
	                            isImplicit: isImplicit                        
	                        });

	                        processed[presentationLabel] = [ projectLinks.length, projectLink.serviceProviders.length - 1 ];
	                        
	                        if (projectLink.serviceProviders.length > 0) {
	                            projectLinks.push(projectLink);
	                        }
	                    	
	                    }

	                }

	            }
	            
	            if (acceptableLinkTypes) {
	            	var dl = new dojo.DeferredList(deferreds);
	            	
	            	var contextObj = {
	            		deferreds: deferreds,
	            		projectLinks: projectLinks,
	            		callback: callback
	            	};
	            	
	            	 dl.then(dojo.hitch(contextObj, function(result){
	                     if (this.callback) {
	                    	 this.callback(projectLinks);
	                     }
	            	 }));
	            } else {
	                if (callback) {
	                    callback(projectLinks);
	                }
	            }
	        }));
	    },

	    _getExplicitProjectLinks: function(projectAreaUri, url) {
	        if (!url) {
	            url = projectAreaUri + "/" + jazz.app.context.get().itemId + "/links"; //$NON-NLS-1$
	        }
	        var epl = new dojo.Deferred();
	        var deferred = jazz.client.xhrGet({
	            url: url,
	            headers: {
	                "accept": "application/xml" //$NON-NLS-1$
	            },
	            handleAs: "xml", //$NON-NLS-1$
	            error: dojo.hitch(this, function(error){
	                console.error(error);
	            })
	        });
	        deferred.addCallback(this, function(result) {
	            var nodes = this._getChildNodes(result);
				var links = UIHelper.getNode(nodes, "links", ProcessConstants.NAMESPACE_JP);
				if (links) {
					linkNodes = UIHelper.getNodes(this._getChildNodes(links), "link", ProcessConstants.NAMESPACE_JP);
				} else {
					linkNodes= UIHelper.getNodes(nodes, "link", ProcessConstants.NAMESPACE_JP);
				}
	            if (!linkNodes) {
	                linkNodes = [];
	            }
	            
//	            for (var i = 0; i < linkNodes.length; i++) {
//	                var serviceProvider = UIHelper.getNodes(this._getChildNodes(linkNodes[i]), "ServiceProvider", ProcessConstants.NAMESPACE_OSLC);
//	                
//	                for (var j = 0; j < serviceProvider.length; j++) {
//	                    var services = UIHelper.getNodes(this._getChildNodes(serviceProvider[j]), "services", ProcessConstants.NAMESPACE_OSLC);
//	                    if (services) {
//	                    	for (var k = 0; k < serviceProvider.length; k++) {
//	                    		 var service = services[k];
//	                    		 //service.attributes
//	                    	} 
//	                    }
//	                }
//	            }
	            
	            epl.resolve(linkNodes);
	        });
	        return epl;
	    },

	    _getImplicitProjectLinks: function(contextForImplicitLinks) {
	        var ipl = new dojo.Deferred();        
	        contextForImplicitLinks.addCallback(this, function(linkNodes) {
	            ipl.resolve(linkNodes);
	        });
	        return ipl;
	    },
	    
	    getAuthneticationUrl: function(serviceProviders, serviceUrl){
	        var _Url= new dojo._Url(serviceUrl);

	        var segment= this.getContext(_Url.path);
	        var authority= _Url.authority;
	        for(var att in serviceProviders){
	            var current= serviceProviders[att];
	            if(current){
	                var url= new dojo._Url(current);
	                var urlSegment= this.getContext(url.path);
	                if (url.authority === authority && urlSegment === segment){
	                    return current;
	                }
	            }
	        }
	        return null;
	    },
	    
	    getContext: function(path){
			var segments= path.split("/");
			for(var index=0; index<segments.length; index++){
				var current= segments[index];
				if(current){
					return current;
				}
			}
	    },
	    
	    _getFriends: function(contextRoot) {
    		var deferredFriends = jazz.client.xhrGet({
    			url: contextRoot + '/friends?right_now='+new Date().getTime(),
    			headers: {
    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
    			},
    			handleAs: "xml" //$NON-NLS-1$
    		});
    		deferredFriends.addErrback(this, function(result, args){
				//if we can't load the friend document, CLM will not work at all
				console.error(result);
				ncFactory.createXhrError({xhrError: result, ioArgs: args}).dispatch();
    		});
    		
    		return deferredFriends;
	    },
	    
	    /* Makes authentication popups appear if necessary so that the user can log in to friend servers */
	    authenticate: function(callback) {
	    	var outerContext = {
	    		callback: callback,
	    		context: this
	    	};
	    	
	    	var deferredFriends = this._getFriends(net.jazz.ajax._contextRoot);
	    	
	    	deferredFriends.then(dojo.hitch(outerContext, function(result) {
	    		
                var rdfNode = this.context._getChildNodes(result);
                var rdfChildNodes = this.context._getChildNodes(rdfNode[0]);
                var friendNodes = UIHelper.getNodes(rdfChildNodes, "Friend", ProcessConstants.NAMESPACE_JD);
    	        var friendRootServices = [];
                for (var index = 0; index < friendNodes.length; index++) {
	                var rootServicesNode = UIHelper.getNode(this.context._getChildNodes(friendNodes[index]), "rootServices", ProcessConstants.NAMESPACE_JD);
	                if (rootServicesNode) {
	                	var rootServicesUrl = rootServicesNode.getAttribute("rdf:resource");
	                	
	                	if (rootServicesUrl) {
		                	friendRootServices.push(rootServicesUrl);
	                	}
	                	
	                }
                }
                
                result = friendRootServices;
	    		
		    	var deferreds = []; 
	    		
	            for (var index = 0; index < result.length; index++) {
	                var rootServicesUrl = result[index];

    				var deferred = new dojo.Deferred(function(reason){});
    				deferreds.push(deferred);
	                
	                var context = {
	                		deferreds: deferreds,
	                		context: this.context,
	                		deferred: deferred
	                };
	                
            		var deferredRootservices = jazz.client.xhrGet({
            			url: rootServicesUrl,
            			headers: {
            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
            			},
            			handleAs: "xml", //$NON-NLS-1$
            			error: dojo.hitch(context, function(error){
            				//this is perfectly fine; the server may be
            				//down
            				//make sure to resolve the def in order not
            				//to prevent this from completing and
            				//successful servers from being added to the
            				//result
            				console.error(error);
            			})
            		});
            		
            		deferredRootservices.addCallback(context, function(result){
            			
            			var d = this.deferred;
            			var context2 = {
            				d: d,
            				context: this.context
            			};
            			
                        var descriptionNode = UIHelper.getNode(this.context._getChildNodes(result), "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
                        
	                        if (descriptionNode) {
	                        	
		                        var provider = UIHelper.getNode(this.context._getChildNodes(descriptionNode), "cmServiceProviders", ProcessConstants.NAMESPACE_OSLC_CM);
		                        
		                        if (provider) {
		                        	
			                        var res = provider.getAttribute("rdf:resource");
			                        
			                        if (res) {
			                        	context2.res = res;
			                        	
			                    		var deferredCatalog = jazz.client.xhrGet({
			                    			url: res,
			                    			headers: {
			                    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
			                    				"OSLC-Core-Version": "2.0",
			                    				"X-rmps-internal": "true"
			                    			},
			                    			handle: dojo.hitch(context2, function(result){
			                    				//this.d.resolve(this.res);
			                    			}),		                    			
			                    			handleAs: "xml", //$NON-NLS-1$
			                    			error: dojo.hitch(context2, function(error){
			                    				this.d.resolve();
			                    				console.error(error);
			                    				return error;
			                    			})
			                    		});
			                    		
			                    		
			                    		deferredCatalog.addCallback(context2, function(result){
			                    			var rdfNode = UIHelper.getNode(this.context._getChildNodes(result), "RDF", ProcessConstants.NAMESPACE_RDF);
			                    			
			                    			var resolved = false;
			                    			
			                    			if (rdfNode) {
				                                var serviceProviderCatalogNode = UIHelper.getNode(this.context._getChildNodes(rdfNode), "ServiceProviderCatalog", ProcessConstants.NAMESPACE_OSLC_CORE);
				                                
				                                if (serviceProviderCatalogNode) {
		
					                                var serviceProviderNodes = UIHelper.getNodes(this.context._getChildNodes(serviceProviderCatalogNode), "serviceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
					                                
					                                if (serviceProviderNodes) {
		
					                                	var list = [];
					                                	for (var index = 0; index < serviceProviderNodes.length; index++) {
					                                		var serviceProviderNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNodes[index]), "ServiceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
					                                		if (serviceProviderNode) {
						                                		var res = serviceProviderNode.getAttribute("rdf:about");
						                                		
						                                		var titleNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNode), "title", ProcessConstants.NAMESPACE_DC);
						                                		var detailsNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNode), "details", ProcessConstants.NAMESPACE_OSLC_CORE);
						                                		
						                                		
						                                		if (res) {
							                                		var title, details;
							                                		if (titleNode) {
							                                			title = titleNode.textContent;
							                                			
							                                			if (!title) { //IE8
							                                				title = titleNode.text;
							                                			}
							                                		}
							                                		
							                                		if (detailsNode) {
							                                			details = detailsNode.getAttribute("rdf:resource");
							                                		}
							                                		
							                                		//title and details could be undefined, but res is mandatory
							                                		var resAndTitleAndDetails = {
							                                			res: res,
							                                			title: title,
							                                			details: details
							                                		};
						                                			
							                                		list.push(resAndTitleAndDetails);
						                                		}
					                                		}
					                                	}
			                                			this.d.resolve(list);
			                                			resolved = true;
					                                }
				                                	
				                                }
			                    			} 
			                    			
			                    			if (!resolved) {
			                    				d.resolve();
			                    			}
			                                
			                    		});
			                    		
		
			                        } else {
			                        	//no res
			                        	d.resolve();
			                        }
		                        } else {
		                        	//no provider
		                        	d.resolve();
		                        }
	            		} else {
	            			//no DescriptionNode
	            			d.resolve();
	            		}

                    });
                    
	            }
	            
        		if (this.callback) {
	            	var dl = new dojo.DeferredList(deferreds);
	            	dl.then(dojo.hitch(this, function(result){
	                         this.callback.resolve(result);
	            	 }));
        		}

	        }));
	    	
	    }
	    
	
	};
	
	

}());